##  for Mageia 9  ##

%define ver 1.8.9
%define rel 5

%define git 1
%define git_date 20240826
%if %{git}
%define realrel %{rel}.%{git_date}.np9
%else
%define realrel %{rel}.np9
%endif

%define anthy_version    9100h
%define m17n_lib_version 1.8.0

%define uim_major    8
%define libname_orig lib%{name}
%define libname      %mklibname %{name} %{uim_major}
%define develname    %mklibname %{name} -d

%define custom_major   2
%define libcustom_orig libuim-custom
%define libcustom      %mklibname uim-custom %{custom_major}

%define gcroots_major   0
%define libgcroots_orig libgcroots
%define libgcroots      %mklibname gcroots %{gcroots_major}

%define scm_major 0
%define libscm    %mklibname uim-scm %{scm_major}

# turn off debuginfo package
%define debug_package %{nil}


Name:    uim
Summary: Multilingual input method library 
Version: %{ver}
Release: %{realrel}
Group:   System/Internationalization
License: BSD and LGPLv2+ and (BSD or LGPLv2)
URL:     https://github.com/uim/uim

%if %{git}
Source0: %{name}-%{git_date}.tar.xz
#Source1: get-uim-trunk-code.sh
%else
Source0: https://github.com/uim/uim/releases/download/uim-%{version}/uim-%{version}.tar.bz2
%endif
Source10: mga-uim.desktop

# patch11 from Fedora
Patch11: uim-emacs-utf8.patch

BuildRequires: automake
BuildRequires: cmake
BuildRequires: intltool
BuildRequires: libtool
BuildRequires: anthy-devel >= %{anthy_version}
BuildRequires: emacs-common
BuildRequires: %{_lib}edit-devel
BuildRequires: %{_lib}ncurses-devel
BuildRequires: m17n-lib-devel >= %{m17n_lib_version}
BuildRequires: pkgconfig(gtk+-2.0) >= 2.4.0
BuildRequires: pkgconfig(gtk+-3.0)
BuildRequires: pkgconfig(libnotify) >= 0.4
BuildRequires: pkgconfig(x11)
BuildRequires: pkgconfig(xext)
BuildRequires: pkgconfig(expat)
#
BuildRequires: %{_lib}curl-devel
BuildRequires: %{_lib}qt5core-devel
BuildRequires: %{_lib}qt5widgets-devel
BuildRequires: %{_lib}qt5x11extras-devel
BuildRequires: %{_lib}kf5plasma-devel
#
%if %{git}
BuildRequires: ruby
%endif

Requires: %{libname} = %{version}-%{release}
#Requires: uim-gtk = %%{version}-%%{release}
Requires: uim-gtk3 = %{version}-%{release}
#
Requires: setIM

%description
Uim is a multilingual input method library.
Uim's project goal is to provide secure and useful input method for all languages.

[CAUTION]
This UNOFFICIAL package do NOT support Canna, PRIME, Mana.
This UNOFFICIAL package do NOT include Qt4 plugins.

%post
#if [ $1 = 0 ]; then
#%%{_bindir}/uim-module-manager --unregister-all > /dev/null 2>&1
#fi
if [ $1 = 2 ]; then
  if [ $(rpm -q --quiet uim-mozc) -o $(rpm -q --quiet uim-mozc-ut-neologd) ]; then
    %{_bindir}/uim-module-manager --register mozc > /dev/null 2>&1
  fi
fi

# -------------------------------------------------------------

%package gtk
Summary: gtk2 helper for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: gtk+2
Provides: uim-applet-gtk
Provides: uim-applet = %{version}
Requires(post,postun): gtk+2

%description gtk
gtk2 helper for Uim.
It contains some apps like toolbar, system tray, candidate window for Uim library.

%post gtk
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

%postun gtk
if [ $1 = 0 ]; then
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache
fi

# -------------------------------------------------------------

%package gtk3
Summary: gtk3 helper for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: gtk+3
Provides: uim-applet-gtk3
Provides: uim-applet = %{version}
Requires(post,postun): gtk+3

%description gtk3
gtk3 helper for Uim.
It contains some apps like toolbar, system tray, candidate window for Uim library.

[CAUTION]
This UNOFFICIAL package do NOT support gnome3 applet.

%post gtk3
gtk-query-immodules-3.0 --update-cache

%postun gtk3
if [ $1 = 0 ]; then
gtk-query-immodules-3.0 --update-cache
fi

# -------------------------------------------------------------

%package qt5
Summary: Qt5 helper for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: qtbase5-common
Requires: oxygen-icons5
Provides: uim-qt5immodule = %{version}-%{release}

%description qt5
A plugin for using Uim on qt5-immodule and also provides the helper programs.

# -------------------------------------------------------------

%package base
Summary: Misc files needed by Uim library
Group:   System/Internationalization

%description base
Misc files needed by Uim library.

# -------------------------------------------------------------

%package -n %{libname}
Summary: Uim library
Group:   System/Internationalization
Requires: uim-base = %{version}-%{release}
Provides: %{libname_orig} = %{version}-%{release}

%description -n %{libname}
Uim library.

# -------------------------------------------------------------

%package -n %{develname}
Summary: Headers of Uim for development
Group:   Development/C
Requires: %{libname} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: %{libname_orig}-devel = %{version}-%{release}

%description -n %{develname}
Headers of Uim for development.

# -------------------------------------------------------------

%package -n %{libcustom}
Summary: Custom library for Uim
Group:   System/Internationalization
Requires: %{libname} = %{version}-%{release}
Provides: %{libcustom_orig} = %{version}-%{release}

%description -n %{libcustom}
Custom library for Uim.

# -------------------------------------------------------------

%package -n %{libgcroots}
Summary: Gcroots library for Uim
Group:   System/Internationalization
Requires: %{libname} = %{version}-%{release}
Provides: %{libgcroots_orig} = %{version}-%{release}

%description -n %{libgcroots}
This library abstracts architecture-dependent part of garbage collector roots acquisition such as register windows of SPARC and register stack backing store of IA-64. 

With this library, one can easily write his own garbage collector for small footprint, some application-specific optimizations, just learning or testing experimental ideas.

# -------------------------------------------------------------

%package -n %{libscm}
Summary: Scm library for Uim
Group:   System/Internationalization
Requires: %{libname} = %{version}-%{release}

%description -n %{libscm}
Scm library for Uim.

# -------------------------------------------------------------

%package anthy
Summary: Anthy support for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: anthy >= %{anthy_version}
Requires(post,preun): %{name} = %{version}

%description anthy
This package provides support for Anthy, a Japanese input method.

%post anthy
%{_bindir}/uim-module-manager --register anthy-utf8 > /dev/null 2>&1

%preun anthy
if [ $1 = 0 ] ; then
%{_bindir}/uim-module-manager --unregister anthy-utf8 > /dev/null 2>&1
fi

# -------------------------------------------------------------

%package skk
Summary: SKK support for Uim
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: skkdic
Requires(post,preun): %{name} = %{version}

%description skk
This package provides support for SKK, a Japanese input method.

%post skk
%{_bindir}/uim-module-manager --register skk > /dev/null 2>&1

%preun skk
if [ $1 = 0 ] ; then
%{_bindir}/uim-module-manager --unregister skk > /dev/null 2>&1
fi

# -------------------------------------------------------------

%package m17n
Summary: m17n-lib support for Uim
Group: System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires: m17n-lib >= %{m17n_lib_version}
Requires(post,preun): %{name} = %{version}

%description	m17n
This package provides support for m17n-lib, which allows input of many languages using the input table map from m17n-db.

%post m17n
%{_bindir}/uim-module-manager --register m17nlib > /dev/null 2>&1 || :

%preun m17n
if [ $1 = 0 ]; then
%{_bindir}/uim-module-manager --unregister m17nlib > /dev/null 2>&1 || :
fi

# -------------------------------------------------------------

%prep
%if %{git}
%setup -q -n uim-%{git_date}
%else
%setup -q
%endif

%patch -p1 11

sed -i 's|uim-dict-gtk|uim-dict-gtk3|g' qt4/toolbar/common-quimhelpertoolbar.cpp


%build
export QMAKE5=%{_qt5_bindir}/qmake

%configure \
 --without-anthy \
 --with-anthy-utf8 \
 --with-m17nlib \
 --without-canna \
 --without-prime \
 --without-mana \
 --without-scim \
 --without-eb \
 --with-qt5 \
 --with-qt5-immodule \
 --disable-kde-applet \
 --disable-kde4-applet \
 --disable-gnome-applet \
 --disable-gnome3-applet \
 --disable-rpath \
 --disable-static \
 --enable-dict \
 --enable-pref \
%if %{git}
 --enable-maintainer-mode \
%endif
 --disable-warnings-into-error \
 --enable-default-toolkit=gtk3

%make_build


%install
rm -rf $RPM_BUILD_ROOT
%make_install

# desktop entry
install -m0644 %{SOURCE10} $RPM_BUILD_ROOT%{_datadir}/applications/uim.desktop
mkdir -p $RPM_BUILD_ROOT%{_iconsdir}/hicolor/{48x48,64x64}/apps
cp $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/uim-icon48.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/48x48/apps/uim-icon.png
cp $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/uim-icon64.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/64x64/apps/uim-icon.png

# remove unnecessary files
find $RPM_BUILD_ROOT -name '*.la' -delete

rm -f $RPM_BUILD_ROOT%{_datadir}/uim/anthy.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/anthy-custom.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/scim.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/prime*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/canna*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/mana*.scm
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/scim.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/prime*.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/canna.*
rm -f $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mana.*

# remove docs for sigscheme (they should be installed by %%doc)
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/sigscheme

%find_lang %{name}

# -------------------------------------------------------------

%files -f %{name}.lang
%defattr(-,root,root)
%doc AUTHORS COPYING README* INSTALL*
%doc sigscheme/doc/*
%{_bindir}/uim-el*-agent
%{_bindir}/uim-module-manager
%{_bindir}/uim-sh
%{_bindir}/uim-xim
%{_bindir}/uim-help
%{_bindir}/uim-fep*
%{_datadir}/applications/*
%{_datadir}/emacs/site-lisp/uim-el/*.el
%{_mandir}/man1/*
%{_datadir}/uim/pixmaps/*
%{_datadir}/uim/*.scm
%exclude %{_datadir}/uim/pixmaps/anthy.*
%exclude %{_datadir}/uim/pixmaps/skk.*
%exclude %{_datadir}/uim/pixmaps/m17n*
%exclude %{_datadir}/uim/anthy*.scm
%exclude %{_datadir}/uim/skk*.scm
%exclude %{_datadir}/uim/m17n*.scm
%{_datadir}/uim/byeoru-data/byeoru-dict
#%%{_datadir}/uim/helperdata/bushu.t
%{_datadir}/uim/helperdata/uim-dict-ui.xml
%{_datadir}/uim/lib/sigscheme-init.scm
%{_datadir}/uim/lib/srfi-*.scm
%{_datadir}/uim/lib/unittest.scm
%{_datadir}/uim/tables/wb86.table
%{_datadir}/uim/tables/zm.table
%{_iconsdir}/hicolor/*/apps/uim-icon.png

%files gtk
%defattr(-,root,root)
%{_bindir}/uim-input-pad-ja
%{_bindir}/uim-dict-gtk
%{_bindir}/uim-im-switcher-gtk
%{_bindir}/uim-pref-gtk
%{_bindir}/uim-toolbar-gtk
%{_bindir}/uim-toolbar-gtk-systray
%{_libexecdir}/uim-candwin-gtk
%{_libexecdir}/uim-candwin-horizontal-gtk
%{_libexecdir}/uim-candwin-tbl-gtk
%{_libdir}/gtk-2.0/*/immodules/*.so

%files gtk3
%defattr(-,root,root)
%{_bindir}/uim-dict-gtk3
%{_bindir}/uim-im-switcher-gtk3
%{_bindir}/uim-input-pad-ja-gtk3
%{_bindir}/uim-pref-gtk3
%{_bindir}/uim-toolbar-gtk3
%{_bindir}/uim-toolbar-gtk3-systray
%{_libdir}/gtk-3.0/*/immodules/im-uim.so
%{_libexecdir}/uim-candwin-gtk3
%{_libexecdir}/uim-candwin-tbl-gtk3
%{_libexecdir}/uim-candwin-horizontal-gtk3

%files qt5
%defattr(-,root,root)
%{_bindir}/uim-chardict-qt5
%{_bindir}/uim-im-switcher-qt5
%{_bindir}/uim-pref-qt5
%{_bindir}/uim-toolbar-qt5
%{_libexecdir}/uim-candwin-qt5
%{_libdir}/qt5/plugins/platforminputcontexts/libuimplatforminputcontextplugin.so
%{_libdir}/qt5/qml/com/github/uim/libuim-qtquick-plugin.so
%{_libdir}/qt5/qml/com/github/uim/qmldir
%{_datadir}/kservices5/plasma-applet-com.github.uim.status.desktop
%{_datadir}/metainfo/com.github.uim.status.appdata.xml
%{_datadir}/plasma/plasmoids/com.github.uim.status/contents/ui/main.qml
%{_datadir}/plasma/plasmoids/com.github.uim.status/contents/ui/messageProcessor.js
%{_datadir}/plasma/plasmoids/com.github.uim.status/metadata.desktop
%{_datadir}/plasma/plasmoids/com.github.uim.status/metadata.json

%files base
%defattr(-,root,root)
%{_libexecdir}/uim-helper-server
%{_libdir}/uim/plugin/libuim-custom-enabler.so
%{_libdir}/uim/plugin/libuim-editline.so
%{_libdir}/uim/plugin/libuim-fileio.so
%{_libdir}/uim/plugin/libuim-lolevel.so
%{_libdir}/uim/plugin/libuim-look.so
%{_libdir}/uim/plugin/libuim-process.so
%{_libdir}/uim/plugin/libuim-socket.so
%{_libdir}/uim/plugin/libuim-sqlite3.so
%{_libdir}/uim/plugin/libuim-xkb.so

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libuim.so.%{uim_major}*

%files -n %{libgcroots}
%defattr(-,root,root)
%{_libdir}/libgcroots.so.%{gcroots_major}*

%files -n %{libcustom}
%defattr(-,root,root)
%{_libdir}/libuim-custom.so.%{custom_major}*

%files -n %{libscm}
%defattr(-,root,root)
%{_libdir}/libuim-scm.so.%{scm_major}*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc

%files anthy
%defattr(-,root,root)
%{_libdir}/uim/plugin/libuim-anthy-utf8.so
%{_datadir}/uim/anthy*.scm
%{_datadir}/uim/pixmaps/anthy.*

%files skk
%defattr(-,root,root)
%{_libdir}/uim/plugin/libuim-skk.so
%{_datadir}/uim/skk*.scm
%{_datadir}/uim/pixmaps/skk.*

%files m17n
%defattr(-,root,root)
%{_bindir}/uim-m17nlib-relink-icons
%{_libdir}/uim/plugin/libuim-m17nlib.so
%{_datadir}/uim/m17nlib.scm
%{_datadir}/uim/m17nlib-custom.scm
%{_datadir}/uim/pixmaps/m17n*


%changelog
* Wed Sep 11 2024 tomcat <> 1.8.9-5.20240826.np9
- update to 20240826 (commit_id:2041287)

* Thu May 16 2024 tomcat <> 1.8.9-4.20240306.np9
- fix BR

* Fri Apr 26 2024 tomcat <> 1.8.9-3.20240306.np9
- update to 20240306 (commit_id:f7cdc9d)

* Sun Feb 26 2023 tomcat <> 1.8.9-2.np9
- build for Mageia 9

* Fri Aug 19 2022 tomcat <> 1.8.9-1.nora8
- update to 1.8.9

* Thu Aug 18 2022 tomcat <> 1.8.9-0.20220626.nora8
- update to 20220626 (rev.24a68ae)

* Mon Mar 21 2022 tomcat <> 1.8.9-0.20220318.nora8
- update to 20220318 (rev.6d8fcc8)
- update %%files
- fix %%post
- now do not build qt4 plugins

* Sat Apr 03 2021 tomcat <> 1.8.9-0.1.d1ac9d9.nora8
- rev.d1ac9d9
